org.apache.commons.pool2.impl

## Class SoftReferenceObjectPool<T>

- java.lang.Object
- - org.apache.commons.pool2.BaseObject
  - - org.apache.commons.pool2.BaseObjectPool<T>
    - - org.apache.commons.pool2.impl.SoftReferenceObjectPool<T>

- Type Parameters:
    `T` - Type of element pooled in this pool.
  All Implemented Interfaces:
    ObjectPool<T>

      public class SoftReferenceObjectPool<T>
      extends BaseObjectPool<T>

  A `SoftReference` based `ObjectPool`.

  This class is intended to be thread-safe.

  Since:
    2.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SoftReferenceObjectPool(PooledObjectFactory<T> factory)` Create a `SoftReferenceObjectPool` with the specified factory.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addObject()` Create an object, and place it into the pool.
    `T` | `borrowObject()` Borrow an object from the pool.
    `void` | `clear()` Clears any objects sitting idle in the pool.
    `void` | `close()` Close this pool, and free any resources associated with it.
    `PooledObjectFactory<T>` | `getFactory()` Returns the `PooledObjectFactory` used by this pool to create and manage object instances.
    `int` | `getNumActive()` Return the number of instances currently borrowed from this pool.
    `int` | `getNumIdle()` Returns an approximation not less than the of the number of idle instances in the pool.
    `void` | `invalidateObject(T obj)` Invalidates an object from the pool.
    `void` | `returnObject(T obj)` Returns an instance to the pool after successful validation and passivation.
    `protected void` | `toStringAppendFields(StringBuilder builder)` Used by sub-classes to include the fields defined by the sub-class in the `BaseObject.toString()` output.

    - ### Methods inherited from class org.apache.commons.pool2.BaseObjectPool

      `assertOpen, isClosed`

    - ### Methods inherited from class org.apache.commons.pool2.BaseObject

      `toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### SoftReferenceObjectPool

          public SoftReferenceObjectPool(PooledObjectFactory<T> factory)

      Create a `SoftReferenceObjectPool` with the specified factory.
      Parameters:
        `factory` - object factory to use.

  - ### Method Detail

    - #### borrowObject

          public T borrowObject()
                         throws Exception

      Borrow an object from the pool. If there are no idle instances available in the pool, the configured factory's `PooledObjectFactory.makeObject()` method is invoked to create a new instance.

      All instances are `activated` and `validated` before being returned by this method. If validation fails or an exception occurs activating or validating an idle instance, the failing instance is `destroyed` and another instance is retrieved from the pool, validated and activated. This process continues until either the pool is empty or an instance passes validation. If the pool is empty on activation or it does not contain any valid instances, the factory's `makeObject` method is used to create a new instance. If the created instance either raises an exception on activation or fails validation, `NoSuchElementException` is thrown. Exceptions thrown by `MakeObject` are propagated to the caller; but other than `ThreadDeath` or `VirtualMachineError`, exceptions generated by activation, validation or destroy methods are swallowed silently.

      Specified by:
        `borrowObject` in interface `ObjectPool<T>`
      Specified by:
        `borrowObject` in class `BaseObjectPool<T>`
      Returns:
        a valid, activated object instance
      Throws:
        `NoSuchElementException` - if a valid object cannot be provided
        `IllegalStateException` - if invoked on a `closed` pool
        `Exception` - if an exception occurs creating a new instance

    - #### returnObject

          public void returnObject(T obj)
                            throws Exception

      Returns an instance to the pool after successful validation and passivation. The returning instance is destroyed if any of the following are true:
      - the pool is closed
      - `validation` fails
      - `passivation` throws an exception
      Exceptions passivating or destroying instances are silently swallowed. Exceptions validating instances are propagated to the client.
      Specified by:
        `returnObject` in interface `ObjectPool<T>`
      Specified by:
        `returnObject` in class `BaseObjectPool<T>`
      Parameters:
        `obj` - instance to return to the pool
      Throws:
        `IllegalStateException` - if an attempt is made to return an object to the pool that is in any state other than allocated (i.e. borrowed). Attempting to return an object more than once or attempting to return an object that was never borrowed from the pool will trigger this exception.
        `Exception` - if an instance cannot be returned to the pool

    - #### invalidateObject

          public void invalidateObject(T obj)
                                throws Exception

      Invalidates an object from the pool.

      By contract, `obj` must have been obtained using `ObjectPool.borrowObject()` or a related method as defined in an implementation or sub-interface.

      This method should be used when an object that has been borrowed is determined (due to an exception or other problem) to be invalid.

      Specified by:
        `invalidateObject` in interface `ObjectPool<T>`
      Specified by:
        `invalidateObject` in class `BaseObjectPool<T>`
      Parameters:
        `obj` - a `borrowed` instance to be disposed.
      Throws:
        `Exception` - if the instance cannot be invalidated

    - #### addObject

          public void addObject()
                         throws Exception

      Create an object, and place it into the pool. addObject() is useful for "pre-loading" a pool with idle objects.

      Before being added to the pool, the newly created instance is `validated` and `passivated`. If validation fails, the new instance is `destroyed`. Exceptions generated by the factory `makeObject` or `passivate` are propagated to the caller. Exceptions destroying instances are silently swallowed.

      Specified by:
        `addObject` in interface `ObjectPool<T>`
      Overrides:
        `addObject` in class `BaseObjectPool<T>`
      Throws:
        `IllegalStateException` - if invoked on a `closed` pool
        `Exception` - when the `factory` has a problem creating or passivating an object.

    - #### getNumIdle

          public int getNumIdle()

      Returns an approximation not less than the of the number of idle instances in the pool.
      Specified by:
        `getNumIdle` in interface `ObjectPool<T>`
      Overrides:
        `getNumIdle` in class `BaseObjectPool<T>`
      Returns:
        estimated number of idle instances in the pool

    - #### getNumActive

          public int getNumActive()

      Return the number of instances currently borrowed from this pool.
      Specified by:
        `getNumActive` in interface `ObjectPool<T>`
      Overrides:
        `getNumActive` in class `BaseObjectPool<T>`
      Returns:
        the number of instances currently borrowed from this pool

    - #### clear

          public void clear()

      Clears any objects sitting idle in the pool.
      Specified by:
        `clear` in interface `ObjectPool<T>`
      Overrides:
        `clear` in class `BaseObjectPool<T>`

    - #### close

          public void close()

      Close this pool, and free any resources associated with it. Invokes `clear()` to destroy and remove instances in the pool.

      Calling `addObject()` or `borrowObject()` after invoking this method on a pool will cause them to throw an `IllegalStateException`.

      Specified by:
        `close` in interface `ObjectPool<T>`
      Overrides:
        `close` in class `BaseObjectPool<T>`

    - #### getFactory

          public PooledObjectFactory<T> getFactory()

      Returns the `PooledObjectFactory` used by this pool to create and manage object instances.
      Returns:
        the factory

    - #### toStringAppendFields

          protected void toStringAppendFields(StringBuilder builder)

      Description copied from class: `BaseObject`
      Used by sub-classes to include the fields defined by the sub-class in the `BaseObject.toString()` output.
      Overrides:
        `toStringAppendFields` in class `BaseObjectPool<T>`
      Parameters:
        `builder` - Field names and values are appended to this object

Copyright © 2001–2017 The Apache Software Foundation. All rights reserved.